!= GT_HISTORY_VARINFO Υԡ
!= Copy GT_HISTORY_VARINFO
!
! Authors::   Yasuhiro MORIKAWA
! Version::   $Id: historyvarinfocopy.f90,v 1.2 2009-05-25 09:45:19 morikawa Exp $
! Tag Name::  $Name: gtool5-20090809 $
! Copyright:: Copyright (C) GFD Dennou Club, 2004-2009. All rights reserved.
! License::   See COPYRIGHT[link:../../../COPYRIGHT]
!
  subroutine HistoryVarinfoCopy1(varinfo_dest, varinfo_src, err, &
    & name, dims, longname, units, xtype )
    !
    !== GT_HISTORY_VARINFO ѿԡ
    !
    ! GT_HISTORY_VARINFO ѿ *varinfo_src* 
    ! *varinfo_dest* ˥ԡޤ
    ! *varinfo_src*  HistoryVarinfoCreate ˤäƽꤵƤɬפ
    ! ޤ
    ! °ղäˤ HistoryVarinfoAddAttr
    ! ѤƤ
    !
    ! *err* ͿƤȡԡκݲ餫Զ礬Ƥ
    ! λ err ˤʤä֤ޤ
    !
    ! *err* ʹߤΰϡԡκݤ˾񤭤ͤǤ
    !
    use gtool_history_types, only: GT_HISTORY, GT_HISTORY_AXIS, GT_HISTORY_VARINFO, GT_HISTORY_ATTR
    use gtool_history_internal, only: default, copy_attrs
    use dc_trace, only: BeginSub, EndSub, DbgMessage
    use dc_present,only: present_select
    use dc_string, only: JoinChar
    use dc_error, only: StoreError, DC_NOERR, DC_ENOTINIT, DC_EALREADYINIT
    use dc_types, only: STRING, TOKEN
    implicit none
    type(GT_HISTORY_VARINFO),intent(out):: varinfo_dest
    type(GT_HISTORY_VARINFO),intent(in):: varinfo_src
    logical, intent(out), optional:: err
    character(*) , intent(in), optional:: name     ! ѿ̾
    character(*) , intent(in), optional, target:: dims(:)  ! ¸뼡
    character(*) , intent(in), optional:: longname ! ѿεŪ̾
    character(*) , intent(in), optional:: units    ! ѿñ
    character(*) , intent(in), optional:: xtype    ! ѿη

    integer:: i, stat
    character(STRING):: cause_c
    character(TOKEN), pointer :: srcdims(:) =>null() ! ¸뼡
    character(*), parameter:: subname = "HistoryVarinfoCopy1"
  continue
    call BeginSub(subname)
    stat = DC_NOERR
    cause_c = ''

    if ( .not. varinfo_src % initialized ) then
      stat = DC_ENOTINIT
      cause_c = 'GT_HISTORY_VARINFO'
      goto 999
    end if

    if ( varinfo_dest % initialized ) then
      stat = DC_EALREADYINIT
      cause_c = 'GT_HISTORY_VARINFO'
      goto 999
    end if

    varinfo_dest % name     = present_select('', varinfo_src % name, name)
    varinfo_dest % longname = present_select('', varinfo_src % longname, longname)
    varinfo_dest % units    = present_select('', varinfo_src % units, units)
    varinfo_dest % xtype    = present_select('', varinfo_src % xtype, xtype)

    if (present(dims)) then
      srcdims => dims
    else
      srcdims => varinfo_src % dims
    endif

    call DbgMessage('srcdims=<%c>', &
      & c1=trim(JoinChar(srcdims)))

    allocate(  varinfo_dest % dims( size( srcdims ) )  )
    do i = 1, size(srcdims)
      varinfo_dest % dims(i) = srcdims(i)
    end do

    call DbgMessage('varinfo_dest %% dims=<%c>', &
      & c1=trim(JoinChar(varinfo_dest % dims)))

    if (associated( varinfo_src % attrs ) ) then
      allocate(  varinfo_dest % attrs( size( varinfo_src % attrs) )  )
      call copy_attrs( from = varinfo_src % attrs, &
        &                to = varinfo_dest % attrs, err = err)
    end if

    varinfo_dest % initialized = .true.
999 continue
    call StoreError( stat, subname, err, cause_c )
    call EndSub(subname)
  end subroutine HistoryVarinfoCopy1

  subroutine HistoryVarinfoCopy2(varinfo_dest, varinfo_src, err, &
    & name, dims, longname, units, xtype )
    !
    ! ˡ HistoryVarinfoCopy ƱͤǤ. 
    !
    ! Usage is same as "HistoryVarinfoCopy".
    !
    !--
    ! ̾ Copy Ȥ󶡤뤿δؿǤ. 
    ! ǽ HistoryVarinfoCopy1 ƱǤ. 
    !++
    use gtool_history_types, only: GT_HISTORY, GT_HISTORY_AXIS, GT_HISTORY_VARINFO, GT_HISTORY_ATTR
    use gtool_history_generic, only: HistoryVarinfoCopy
    use dc_trace, only: BeginSub, EndSub, DbgMessage
    implicit none
    type(GT_HISTORY_VARINFO),intent(out):: varinfo_dest
    type(GT_HISTORY_VARINFO),intent(in):: varinfo_src
    logical, intent(out), optional:: err
    character(*) , intent(in), optional:: name     ! ѿ̾
    character(*) , intent(in), optional, target:: dims(:)  ! ¸뼡
    character(*) , intent(in), optional:: longname ! ѿεŪ̾
    character(*) , intent(in), optional:: units    ! ѿñ
    character(*) , intent(in), optional:: xtype    ! ѿη

    character(*), parameter:: subname = "HistoryVarinfoCopy2"
  continue
    call BeginSub(subname)
    call HistoryVarinfoCopy(varinfo_dest, varinfo_src, err, &
      & name, dims, longname, units, xtype )
    call EndSub(subname)
  end subroutine HistoryVarinfoCopy2
